<template>
  <div>
    <BasicTable :clickToRowSelect="false" @register="registerTable" :searchInfo="searchInfo">
      <template #toolbar>
        <Authority value="api:yt:js:post">
          <a-button type="primary" @click="handleCreateOrEdit(null)"> 新增转换脚本 </a-button>
        </Authority>
        <Authority value="api:yt:js:delete">
          <Popconfirm
            title="您确定要批量删除数据"
            ok-text="确定"
            cancel-text="取消"
            @confirm="handleDeleteOrBatchDelete(null)"
          >
            <a-button type="primary" color="error" :disabled="hasBatchDelete"> 批量删除 </a-button>
          </Popconfirm>
        </Authority>
      </template>
      <template #convertJs="{ record }">
        <a-button type="text" @click="handleScriptView(record)">
          <span style="color: #377dff">查看脚本</span>
        </a-button>
      </template>
      <template #action="{ record }">
        <TableAction
          :actions="[
            {
              label: '测试',
              icon: 'ant-design:font-size-outlined',
              auth: 'api:yt:js:test',
              onClick: handleBindTest.bind(null, record),
            },
            {
              label: '编辑',
              icon: 'clarity:note-edit-line',
              auth: 'api:yt:js:update',
              onClick: handleCreateOrEdit.bind(null, record),
              ifShow: record.status == 0,
            },
            {
              label: '删除',
              icon: 'ant-design:delete-outlined',
              auth: 'api:yt:js:delete',
              color: 'error',
              ifShow: record.status == 0,
              popConfirm: {
                title: '是否确认删除',
                confirm: handleDeleteOrBatchDelete.bind(null, record),
              },
            },
          ]"
        />
      </template>
      <template #status="{ record }">
        <Authority value="api:yt:js:update:status">
          <Switch
            :checked="record.status === 1"
            :loading="record.pendingStatus"
            checkedChildren="启用"
            unCheckedChildren="禁用"
            @change="(checked:boolean)=>statusChange(checked,record)"
          />
        </Authority>
      </template>
    </BasicTable>
    <ConverScriptModal @register="registerModal" @success="handleSuccess" />
  </div>
</template>

<script lang="ts" setup>
  import { reactive, nextTick } from 'vue';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  import { searchFormSchema, columns } from './config.data';
  import { Authority } from '/@/components/Authority';
  import { useBatchDelete } from '/@/hooks/web/useBatchDelete';
  import { Switch, Popconfirm } from 'ant-design-vue';
  import { useModal } from '/@/components/Modal';
  import ConverScriptModal from './ConverScriptModal.vue';
  import {
    ScriptPage,
    deleteScriptManage,
    scriptPagePutApi,
  } from '/@/api/scriptmanage/scriptManager';
  import { useMessage } from '/@/hooks/web/useMessage';

  const searchInfo = reactive<Recordable>({});
  const [registerTable, { reload, setProps, setSelectedRowKeys }] = useTable({
    title: '转换脚本列表',
    api: ScriptPage,
    columns,
    showIndexColumn: false,
    clickToRowSelect: false,
    formConfig: {
      labelWidth: 120,
      schemas: searchFormSchema,
      fieldMapToTime: [['sendTime', ['startTime', 'endTime'], 'x']],
    },
    useSearchForm: true,
    showTableSetting: true,
    bordered: true,
    rowKey: 'id',
    actionColumn: {
      width: 200,
      title: '操作',
      dataIndex: 'action',
      slots: { customRender: 'action' },
      fixed: 'right',
    },
  });

  const handleSuccess = () => {
    reload();
  };

  const { hasBatchDelete, handleDeleteOrBatchDelete, selectionOptions, resetSelectedRowKeys } =
    useBatchDelete(deleteScriptManage, handleSuccess, setProps);
  selectionOptions.rowSelection.getCheckboxProps = (record: Recordable) => {
    // Demo:status为1的选择框禁用
    if (record.status === 1) {
      return { disabled: true };
    } else {
      return { disabled: false };
    }
  };

  nextTick(() => {
    setProps(selectionOptions);
  });

  const [registerModal, { openModal }] = useModal();

  // 新增或编辑
  const handleCreateOrEdit = (record: Recordable | null) => {
    if (record) {
      openModal(true, {
        isUpdate: false,
        record,
        isView: false,
        isTest: false,
        isText: 'confirm',
        isTitle: 'edit',
      });
    } else {
      openModal(true, {
        isUpdate: true,
        isView: false,
        isTest: false,
        isText: 'confirm',
        isTitle: 'add',
      });
    }
  };
  const handleBindTest = (record: Recordable | null) => {
    if (record) {
      openModal(true, {
        isUpdate: false,
        record: record.id,
        isTest: true,
        isText: 'test',
        isTitle: 'test',
      });
    }
  };
  const handleScriptView = (record: Recordable | null) => {
    if (record) {
      openModal(true, {
        isUpdate: true,
        record,
        isView: true,
      });
    }
  };
  const statusChange = async (checked, record) => {
    setProps({
      loading: true,
    });
    setSelectedRowKeys([]);
    resetSelectedRowKeys();
    const newStatus = checked ? 1 : 0;
    const { createMessage } = useMessage();
    try {
      await scriptPagePutApi(record.id, newStatus);
      if (newStatus) {
        createMessage.success(`启用成功`);
      } else {
        createMessage.success('禁用成功');
      }
    } finally {
      setProps({
        loading: false,
      });
      reload();
    }
  };
</script>
